/* 
	 1ֳؽ⥳
	 AVR ATTYNY85  avr-gcc (GCC) 4.5.1
	 ԥ󥢥 common.h ڤؤ
	 pin4: GND
	 pin8: Vcc
	 å¢ PLL 16MHz ˤҥ塼
	 # avrdude -E noreset -y -p t85 -c bsd -U lfuse:w:0xf1:m
*/

// hfuse  RST  PB5 ȤȡPB5 Υץ륢å׾֤Ǥϥȥưˤʤ
// ҥ塼ͤ fuseCheck.pl ȡRST ϥץ륢åפ뤳
// RST̵         hfuse=5f
// RST̵+BOD hfuse=5e

// fs.c  fs_str_r(), fs_str_w() ̤ѡ
// 59 ϥܥ꡼Ƚ꤬

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <avr/wdt.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h> 
#include <util/delay.h>
#include <avr/boot.h>

#include "common.h"
#include "main.h"
#include "ir.h"
#include "fs.h"
#include "UART.h"
#include "version.h"

// 9615Hz*2=19200Hz Ƿ׻
// /19200=, =19200*
//#define KEY_C    (53*5*2)  // 30ms
#define KEY_C    (100*5*2)  // 60ms
#define KEY_FIX  (877*5*2) // 460ms
#define KEY_LONG (877*5*2) // 460ms

#define SLEEP_SEC 12

// Хѿ
volatile unsigned char beepcnt=0;    // BEEP Ĥ
volatile unsigned char keyresult=0;  // å
volatile unsigned char longBeepFlag; // LongBeep ե饰
volatile unsigned char errBeepFlag;  // errorBeep ե饰

volatile unsigned char log_ch=0;            // Ф CH ֹ
//volatile unsigned char log_longRepeat=0;  // ĹϢ³
volatile static unsigned long sleepTimer = 0;
volatile unsigned char mode=0;              // ؽ르ꥺ(⡼)
char longPush = 0;
char channelLocked=0;  // ʥ⡼
char dumpModeFlag = 0; // ץ⡼

char twoKeyFlag=1;     // 2⡼
// unsigned char fusebuf[4]; // ҥ塼ɤ߽ФѥХåե
// void fuseread(unsigned char*);

// ߥ졼ط
volatile static signed int chat= 0;       // 㥿ɻߥ
volatile static unsigned char state  = 0; // ۥξ(1 ʤ鲡Ƥ)
volatile static unsigned char prev   = 0;
volatile static unsigned char releaseState = 0; // ꡼򸡽ФȤϿ
volatile static unsigned char pushState = 0;    // ץå򸡽ФȤϿ

// ư˰ꥻåȤ
uint8_t mcusr_mirror __attribute__ ((section (".noinit")));
void get_mcusr(void) __attribute__((naked)) __attribute__((section(".init3")));
void get_mcusr(void) {
	cli(); // ǰΤ߶ػ(̾ϳ)
	mcusr_mirror = MCUSR;
	if (!(mcusr_mirror & (1<<WDRF))) {
		wdt_enable(WDTO_120MS);
		while(1);
	}
	MCUSR = 0;
	//wdt_disable();
} 

// INT0(PB0) ߥϥɥ
SIGNAL(SIG_INTERRUPT0) { 
	if (chat==0) chat=1;
	sleepTimer = 0;
	beepcnt=0;
	interrupt_INT0_UART();
	return; 
}

// 1 A 
ISR(SIG_OUTPUT_COMPARE1A) {
	// BEEP
	static unsigned char bzcnt;
	static unsigned int  localcnt=0;
	// KEY
	static unsigned int push    = 0;
	static unsigned int release = 0;
	static unsigned char cnt    = 0;

	static unsigned char beepDivider = 0;

	// UART 
	UART_interrupt();
	if (UART_cnt>0) return; // UART  KEY  BEEP νϤʤ

	// ץ⡼ɤǤ KEY  BEEP νϤʤ
	if (dumpModeFlag) return;

	// 㥿󥰤ΤʤΥߥ졼
	if (chat==KEY_C && ((PINB & BV(PB_SW))!=0)) chat=-1;
	if (chat>0 && chat< KEY_C) chat++;
	if (chat<0) chat--;
	if (chat== KEY_C) { state=1; }
	if (chat==-KEY_C) { state=0; chat=0; }
	// Ƚ
	if (prev==1 && state==0) { cnt++; release=1; releaseState=1; }
 	if (prev==0 && state==1) { push=1; pushState=1; }
	prev=state;
	if (release==KEY_FIX)  { keyresult=cnt; cnt=0; UART_CMD_CLEAR(); }
	if (push==KEY_LONG) { cnt=255-1; }
	if (release>0 && release<65535) release++;
	if (state==1 && push<65535) push++; else push=0;

	// BEEP (beepcnt ̵)
	if (beepcnt==0)  { bz_off(); return; }
	if (beepDivider++ < 8) return; // BEEP ȿ߼ 1/8 ˤ
	beepDivider = 0;
	if (localcnt==0) {
		beepcnt--;
		if (longBeepFlag && (beepcnt % 2)) localcnt=350; else localcnt = 100; 
	}
	localcnt--;
	if ((beepcnt % 2)==0) return;
	bzcnt++;
	if (bzcnt & (1<<(errBeepFlag*2))) bz_on(); else bz_off(); 
}

//
// ꤷ BEEP 
//
void beep_start(unsigned char times)      { longBeepFlag=0; errBeepFlag=0; beepcnt = times<<1;  }
void longbeep_start(unsigned char times)  { longBeepFlag=1; errBeepFlag=0; beepcnt = times<<1;  }
void errorbeep_start(unsigned char times) { longBeepFlag=0; errBeepFlag=1; beepcnt = times<<1;  }

//
// ᥤ 
//
//int main(void) __attribute__((noreturn));
int main(void) {
	// WDTͭ
	MCUSR = 0;
	wdt_enable(WDTO_8S); 

	// ߶ػ
	cli();

	// ѿ
	// I/O ݡȤ
	DDRB = BV(PB_SENSORPW) | BV(PB_BZ); // (PB1(LED)  ir_init() ǽϤꤹ)

	// 
	GTCCR |= BV(TSM);     // 곫
	TCCR1 |= BV(CTC1);    // 1  OCR1C ư

	TCCR1 |= BV(CS12);    // 1 8ʬ
	OCR1A = (104);        // 1 ѥ(16MHz/8ʬ/104 = 19200Hz, 880Hz)
	OCR1C = (104);        // 1 ưѥ
	TIMSK |= BV(OCIE1A);  // 1 A ߵ
	GTCCR &= ~BV(TSM);    // 꽪λ

	// ץ륢å: ʤ
	// PORTB |= (BV(PB_SENSOR) | BV(PB_SW) | BV(PB5)); // IR/SW, PB5  RST

	// 
	set_sleep_mode(SLEEP_MODE_PWR_DOWN);
	ACSR |= BV(ACD);                 // ѥ졼ػ
	PRR  |= (BV(PRUSI) | BV(PRADC)); // USI,ADC Ÿ

	// Ƶǽ
	ir_init();
	fs_init();

	// INT0 
	INT0_DOWN();
	GIMSK |= BV(INT0);

	// ŸޤԤ
	_delay_ms(100);
  
	// ҥ塼ɤ߽Ф: avr/boot.h  include Ƥ
	//  FUSE_RSTDISBL Ȥʤ
	if (boot_lock_fuse_bits_get(GET_HIGH_FUSE_BITS) & (1<<7)) twoKeyFlag=0;

	// ߵ(߳ϰ֤)
	sei();

  // ץ⡼ɳȽ
	// ҥ塼 2KEY ⡼ɤλϥץ⡼ɤˤʤ
	//if ((PINB & BV(PB_SW))==0 && twoKeyFlag==0) dumpModeLoop(); // δؿ return ʤ

  // ư
  if (twoKeyFlag) beep_start(3); else beep_start(2);
	_delay_ms(100);

	while(1) {
		wdt_reset();  // WDT Υꥻå
		int0_disable();
		ir_polling();
		int0_enable();

		// 2KEY ⡼Ƚ
		if (twoKeyFlag && ((PINB & BV(PB5))!=0)) goto twoKeyJumpLabel1;

		pushState=0; // ͥå

		// ͥåν(keyresult ¸)
		if (channelLocked) {
			// ꡼ư
			if (releaseState) {
				if (log_ch==0) log_ch=1;
				if (ir_load(log_ch) == FS_OK) {
					int0_disable();
					ir_start_send(1); 
					int0_enable();
				}
				releaseState=0;
			} // ꡼
		} else releaseState=0; // ͥå

		// Ĺ
		if (keyresult>=14) {
			// ͥåβ
			if (channelLocked) {
				channelLocked = 0;
				beep_start(4);
				keyresult=0;
				longPush=0;
				continue;
			}
			mode=longPush;
			if (longPush<2) longPush++;
			keyresult=0; 
			// 
			if (mode==0) { beep_start(1); }
			// ؽ
			if (mode==1 || mode==2) {
				if (log_ch==0) log_ch=1;
				irsens_on();
				_delay_ms(100);
				longbeep_start(mode); while(beepcnt);
				int0_disable();
				ir_start_receive(log_ch);
				int0_enable();
			}
			continue;
		} // Ĺ
		
		// ñȲ
		if (!channelLocked && keyresult>0 && keyresult<=13) {
			// 10: ʤˤ⤷ʤ
			if (keyresult==10) goto next_nothing;
			// ֳ
			if (keyresult>=1 && keyresult<=6) {
				log_ch=keyresult;
				unsigned char result = ir_load(keyresult);
				if (result==FS_OK) {
					// loadedmode ѻ
					int0_disable();
					ir_start_send(1);
					int0_enable();
				} else {
					if (result==FS_CHECKSUMERROR) errorbeep_start(5); else errorbeep_start(1);
				}
				goto next_clearkey;
			}
			// 7:  BEEP
			if (keyresult==7) {
				unsigned char nn;
				nn = (unsigned int)((fs_filesize(log_ch)+4) >> 5)+1;
				if (nn==0) nn=1;
				longbeep_start(nn);
				goto next_clearkey;
			}
			// 8:  BEEP
			if (keyresult==8) {
				unsigned char nn;
				nn = (unsigned int)(fs_free() >> 5)+1;
				longbeep_start(nn);
				goto next_clearkey;
			}
			// 9: ͥå
			if (keyresult==9) {
				channelLocked=1;
				keyresult=0;
				mode=0;
				beep_start(3);
				goto next_clearkey;				
			}
			// 11: ñͥ
			if (keyresult==11) {
				if (fs_delete(log_ch)==FS_OK) longbeep_start(4); else errorbeep_start(4);
				goto next_clearkey;				
			}
			// 12: EEPROM õ
			if (keyresult==12) {
				uint8_t *i;
				for (i=0; i<EEPROM_FS+FS_SIZE; i++) eeprom_write_byte(i,0xff);
				longbeep_start(5); while(beepcnt);
				wdt_enable(WDTO_120MS); while(1); // WDT ˤꥻå
			}
			// 13: ץ⡼
			if (keyresult==13) {
				// debug: ʤʤΤǥȥȡʤˤ⤷ʤ
				// dumpModeLoop(); // δؿ return ʤ
				goto next_nothing;
			}
		next_clearkey:
			keyresult=0;
			longPush=0;
		next_nothing:
			;
		} // ñȲ

	twoKeyJumpLabel2:
		
		{	
			// SLEEP
			if (sleepFlip) { sleepFlip=0; sleepTimer++; }
			if (sleepTimer>72000*SLEEP_SEC && ir_flag_status()==IR_FLAG_STOP && beepcnt==0) {
				longPush=0;
				keyresult=0;
				bz_off(); 	                      // BEEP 
				IR_OUT_PORT &= ~_BV(IR_OUT_BIT);	// IR 
				irsens_off();                     // IRsensor Ÿ OFF
				sleepTimer = 0;
				INT0_LOWLEVEL(); // INT0 ٥ߤѹ
				wdt_disable();
				cli();
				sleep_enable();
				sleep_bod_disable();
				sei();
				sleep_cpu();
				sleep_disable();
				wdt_enable(WDTO_8S); 
				INT0_DOWN();	   // INT0 Ωߤ᤹
				interrupt_INT0_UART(); // UART 
			} // if (sleepTimer...)
		} // SLEEP
		
	} // while(1)
	return 1;

	// 2KEY ⡼ü
 twoKeyJumpLabel1:

	// ѤΥꥢ
	keyresult = 0;
	longPush  = 0;

	// ȥ
	{
		static char toggleCh=0;
		// ץåư
		if (pushState) {
			if (ir_load(toggleCh+1)==FS_OK) {
					int0_disable();
					ir_start_send(1); 
					int0_enable();
				}	else errorbeep_start(1); // ir_load()
			toggleCh ^= 1;
			pushState=0;
		} // ꡼
	}
	goto twoKeyJumpLabel2;

} // main()

// 13 ܤ
unsigned int times13(unsigned int x) { return (x<<3)+(x<<2)+x; }


//
// ץ⡼(̵¥롼סreturn ʤ)
//
void dumpModeLoop(void) {
  char buf[8];
  dumpModeFlag = 1;
	ir_receiveCancelDisable = 1;
	mode=3; // 2ܤĹ L ǳؽλʤ(1:,2:ʤ,3:TOO LONG Ǥɽ)
	ir_last_result=IR_RESULT_NONE; // ɽ

  UART_CLS();
  UART_puts_P(PSTR(VERSION));
  UART_puts_P(PSTR("\r\n--IRDAT(us)"));

  while(1) {
		wdt_reset();  // WDT Υꥻå

		int0_disable();
		ir_polling();
		int0_enable() ;

		// ؽλϳؽ̤򥷥ꥢ˽Ϥ弡γؽ򥹥
		if (ir_flag_status()==IR_FLAG_STOP) {
			if (ir_last_result==IR_RESULT_NORAM) UART_puts_P(PSTR("TOOLONG\r\n"));
			if (ir_last_result==IR_RESULT_NOROM) UART_puts_P(PSTR("DSKFULL\r\n"));
			if (ir_last_result==IR_RESULT_SUCCESS) {
				unsigned int worddata;
				unsigned char *pt;
				unsigned int cnt=0;

				odd = 1;
				run = standard[0] = standard[1] = 0;

				// ̸η̤ɽϥȥȤ򳰤
				// ir_load(7); 
				
				pt = (unsigned char *)ir_data;

				while (pt<ir_data+ir_data_size) {
					worddata = expandRead(&pt);
					cnt++;
					// 13ܤɽ
					// UART_puts(strMultiDecimal(buf, (unsigned long)worddata*13));
					UART_puts(strMultiDecimal(buf, times13((worddata>>3)) /125)+3);
					//					UART_puts(strMultiDecimal(buf, (worddata * 13) % 1000)+3);
					UART_puts(strMultiDecimal(buf, times13(worddata) % 1000)+3);

					UART_puts("\r\n");
				} // while 

				UART_puts_P(PSTR("PULSECOUNT=")); UART_puts(strMultiDecimal(buf, cnt));
				UART_puts_P(PSTR("\r\nIRDATASIZE=")); UART_puts(strMultiDecimal(buf, ir_data_size));
				UART_puts_P(PSTR("\r\nFILESIZE=")); UART_puts(strMultiDecimal(buf, fs_filesize(7)));
				UART_puts_P(PSTR("\r\nON-LONG=  ")); UART_puts(strMultiDecimal(buf, times13(long_on))); 
				UART_puts_P(PSTR("\r\nON-SHORT= ")); UART_puts(strMultiDecimal(buf, times13(short_on))); 
				UART_puts_P(PSTR("\r\nOFF-LONG= ")); UART_puts(strMultiDecimal(buf, times13(long_off))); 
				UART_puts_P(PSTR("\r\nOFF-SHORT=")); UART_puts(strMultiDecimal(buf, times13(short_off)));

			} // if (ir_last_result==IR_RESULT_SUCCESS)

			UART_puts_P(PSTR("\r\n\r\nRDY.\r\n"));
			irsens_on();
			_delay_ms(100);

			int0_disable();
			ir_start_receive(7);
			int0_enable();

		} // if (ir_flag_status()==IR_FLAG_STOP) 
	} // while(1)

}

//
// ʸѿ10ʸ
//
char* strDecimal(char *p, unsigned int c) {
  p[0] = c/100 + '0';
  p[1] = (c%100)/10 + '0';
  p[2] = c%10 + '0';
  p[3] = '\0';
  return p;
}

//
// 610ɽ
//
char* strMultiDecimal(char *p, unsigned int c) {
  strDecimal(p, c/1000);
  strDecimal(p+3, c%1000);
  return p;
}

//
// ʸѿ16ʸ
/*
char* strHex(char *p, unsigned int c) {
  p[0] = ((c>>4) < 10) ? (c>>4) + '0' : (c>>4) + 'A' - 10;
  p[1] = ((c & 0x0f) < 10) ? (c & 0x0f) + '0' : (c & 0x0f) + 'A' - 10;
  p[2] = '\0';
  return p;
}
*/

// 󥻥
// #define KEY_CANCEL()  do { chat=0; state=0; prev=0; } while(0)
void KEY_CANCEL(void) {
	chat=0; state=0; prev=0; 
}

